from General                          import findFormContainer
from HTMLForm                         import HTMLForm
from SmartSection                     import SmartSection
from SmartSectionElement              import SmartSectionElement
from Products.Formulator              import StandardFields

import time, string


def manage_addSmartCellForm(self, REQUEST):
    ''' '''
    root = findFormContainer(self)
    if not hasattr(root, 'edit_SmartCellForm'):
        form = HTMLForm('edit_SmartCellForm', 'Edit Form for Smart Cells')
        form.manage_changeProperties(addAction  = 'manage_addSmartCell',
                                     editAction = 'manage_edit_properties')

    return REQUEST.RESPONSE.redirect('../../manage_addSmartCell')
    

def manage_addSmartCell(self, id='', title='', nextURL='', position=0, REQUEST=None, returnId=0):
    ''' '''

    if not id: id  = str(long(time.time()*1000))
    
    cell = SmartCell(id, title)
    self._setObject(id, cell, position)

    if returnId:
        return id
    elif REQUEST:
        return self.manage_main(self, REQUEST)


class SmartCell(SmartSection, SmartSectionElement):
    ''' '''

    meta_type = 'Smart Cell'

    _properties = ()

    __init__ = SmartSectionElement.__init__

    old_render = SmartSection.render

    def render(self, mode='view'):
        ''' '''
        html =        '<td>\n'
        html = html + self.old_render(mode='short')
        html = html + '</td>\n'
        return html
